//
//		  Programming Assignment #2 for CS 130 Fall '05
//
//			        Victor Zordan
//		
//		
//
/***************************************************************************/

#include <GL/glut.h>
#include <cstdlib>       //for exit
#include <cstdio>        //for printf
#include <cmath>
#include "vector.h"      //class Vector

//global variables

//viewport (parallel to x-y plane)
int width = 500;
int height = 500;
Point center( 0, 0, 500 );  //center of view window
Point eye( 0, 0, 1000 );    //position of viewer

//single sphere in the scene
double sphere_radius = 200.0;          //radius of the sphere
Point sphere_center( 0.0, 0.0, 0.0 );  //center of the sphere

/***************************************************************************/

//initialize window
void init()
{
   /* Clear the window */
   glClearColor( 0.0, 0.0, 0.0, 0.0 );
   glShadeModel( GL_SMOOTH );
   glOrtho( 0, width, 0, height, -1.0, 1.0 );
}

//writes pixel as specified color
void write_pixel_color( int x, int y, double r, double g, double b )
{
   glColor3f( r, g, b );
   glBegin( GL_POINTS );
     glVertex3i( x, y, 0);
   glEnd();
}

//perform ray-tracing
void raytrace()
{
   //window is width x height
   double left = center._x - width / 2;
   double bottom = center._y - height / 2;

   //x & y are in screen coordinate
   for ( int x = 0; x < width; x++ )
   {
      for ( int y = 0; y < height; y++ )
      {
	 //pixel in world coordinate: 
	 //x = x + left, y = y + bottom
	 Point pixel( x + left, y + bottom, center._z );

	 //vector (or ray) from eye to the current pixel
	 Vector eye_ray( pixel - eye );
	 
	 ////////////////////////////////////////////////////////
	 // TODO:                                                 
	 // check if eye ray intersects with objects in the scene
	 // (FOR LAB: objects = single sphere)
	 //                                                       
	 // if intersect then                                     
	 //   calculate & apply shading
	 //   (FOR LAB: write pixel (x,y) white)
	 // else
	 //   assign background color
	 ////////////////////////////////////////////////////////

	 // see below for the use of Vector class...

      }
   }

   /******************************************************/
   // To use the Vector class,
   // Vector v( i, j, k, p );    //direction = <i, j, k>, origin = p
   // Vector v( i, j, k );       //direction = <i, j, k>, origin = (0,0,0)
   // Vector v( p2 - p1 );       //direction = p1 to p2, origin = p1
   // Vector v( v2 );            //copy of v2
   //
   // you can get info of Vector v by (uncomment to test):
   //
   // Vector v( Point( 250, 250, 500 ) - eye );
   // printf( "direction (x_dir, y_dir, z_dir): %f, %f, %f\n", 
   //	   v._i, v._j, v._k );
   // printf( "origin (x_0, y_0, z_0): %f, %f, %f\n",
   //	   v._origin._x, v._origin._y, v._origin._z );
   // printf( "length: %f\n", v.getLength() );   
   //
   // use "normalize" to normalize Vector:
   // v.normalize();
   /******************************************************/
}

//display callback
void display()
{
   //clear buffer
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   //raytrace current scene
   raytrace();

   //draw frame buffer
   glutSwapBuffers();
}
 
//keyboard callback
void keyboard ( unsigned char key, int x, int y )
{
   switch ( key ) 
   {
      case 27:             //when ESC is pressed...
	 exit( 0 );        //exit
	 break;
      default:
	 break;
   }
}

//idle callback
void idle()
{
   //"refresh" window
   glutPostRedisplay();
   glutIdleFunc( NULL );
}

//reshape callback
void reshape( int w, int h )
{
   //resize window
   width = w;
   height = h;
}

int main( int argc, char *argv[] )
{
   glutInit            ( &argc, argv ); 
   glutInitDisplayMode ( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH ); 
   glutInitWindowSize  ( width, height ); 
   glutCreateWindow    ( "Riverside Graphics" ); 
   glutDisplayFunc     ( display );  
   glutReshapeFunc     ( reshape );
   glutKeyboardFunc    ( keyboard );
   
   init();            //create_window
   glutMainLoop();    //go into glut loop
}
