//point.cpp

//function definitions for class Point in point.h

#include "point.h"

//default constructor
Point::Point() 
{}

//constructor that sets x,y,z values
Point::Point( double x, double y, double z ) 
   :_x( x ), 
    _y( y ), 
    _z( z ) 
{}

//copy constructor
Point::Point( const Point &p )
   :_x( p._x ), 
    _y( p._y ), 
    _z( p._z )
{}

//assignment operator
Point& Point::operator=( const Point &p )
{
   //avoid self-assignment
   if ( this != &p )
   {
      _x = p._x;
      _y = p._y;
      _z = p._z;
   }
   return *this;
}
