//vector.cpp

//function definitions for class Vector in vector.h

#include <cmath>    //for sqrt
#include <cstdio>
#include <cstdlib>
#include "vector.h"

using namespace std;

//default constructor
Vector::Vector()
{}

//constructor that sets components
Vector::Vector( double i, double j, double k, const Point &origin )
   :_i( i ),
    _j( j ),
    _k( k ),
    _origin( origin )
{}

//copy constructor
Vector::Vector( const Vector &rhs )
   :_i( rhs._i ),
    _j( rhs._j ),
    _k( rhs._k ),
    _origin( rhs._origin )
{}

//assignment operator
Vector& Vector::operator=( const Vector &rhs )
{
   //avoid self-assignment
   if ( this != &rhs )
   {
      //copy components & length
      _i = rhs._i;
      _j = rhs._j;
      _k = rhs._k;
      _origin = rhs._origin;
   }
   return *this;
}

//calculates & returns length
double Vector::getLength() const
{
   double temp = _i * _i + _j * _j + _k * _k;
   
   return sqrt( temp );
}

//normalize vector
void Vector::normalize()
{
   double len = getLength();

   _i /= len;
   _j /= len;
   _k /= len;
}

//subtract dest - orig to obtain vector
Vector operator-( const Point &dest, const Point &orig )
{
   //components = dest - orig, origin = orig
   Vector v( dest._x - orig._x,
	     dest._y - orig._y,
	     dest._z - orig._z,
	     orig );

   return v;
}
