//vector.h

//class definition for Vector

#ifndef VECTOR_H
#define VECTOR_H

#include "point.h"

//defines vector by components
class Vector
{
  public:
   Vector();
   Vector( double i, double j, double k, 
	const Point &origin = Point( 0.0, 0.0, 0.0 ) );
   Vector( const Vector &rhs );
   Vector& operator=( const Vector &rhs );
   double getLength() const;
   void normalize();

   double _i;      //i component
   double _j;      //j component
   double _k;      //k component
   Point _origin;  //origin of vector; (0,0,0) by default
};

//subtract points (dest - orig) to obtain vector
Vector operator-( const Point &dest, const Point &orig );

#endif
